<?
class apk_io
{
	var $ch;

	function apk_io($url)
	{
		if(!preg_match("/^[a-z]{3,}:\/\//i", $url, $m) && file_exists($url))
		{
			$url = "file://".$url;
		}
		else if(preg_match("/^ftp\./i", $url, $m)
		{
			$url = "ftp://".$url;
		}
		else if(preg_match("/^[a-z]+\./i", $url, $m)
		{
			$url = "http://".$url;
		}

		$this->ch = curl_init($url);
		curl_setopt($this->ch, CURLOPT_HEADER, 0);
	}

	function set_output($path, $force_overwrite)
	{
		$this->outpath = $path;
		$this->forceoverwrite = $force_overwrite;
	}

	function download()
	{
		if(file_exists($this->outpath) && !($this->forceoverwrite))
			$this->resume();

		$fp = fopen($this->outpath, "w");

		if($fp)
		{
			curl_setopt($this->ch, CURLOPT_FILE, $fp);
			curl_exec($this->ch);
			fclose($fp);
		}
	}

	function resume()
	{
		$csize = filesize($this->outpath);

		$fp = fopen($this->outpath, "a");

		if($fp)
		{
			curl_setopt($this->ch, CURLOPT_RESUME_FROM, $csize);
			curl_exec($this->ch);
			fclose($fp);
		}
	}
}
?>
